#-----FR_reverseDirContent search from the Startdirectory away after files
#-----with an overtaken suffix

#---using: ::FR_reverseDirContent::Start {StartDir HiddenDir HiddenFile FileType}
#
#---StartDir: directory where the search starts
#---HiddenDir: 0 for leave away hidden dirs, 1 for including hidden dirs
#---HiddenFile: 0 for leave away hidden files, 1 for including hidden files
#---FileType: the file pattern for the glob command


package provide FR_reverseDirContent 0.1


namespace eval ::FR_reverseDirContent \
{
  namespace export Start
 
  variable SearchList
}


#---here starts the search...
proc ::FR_reverseDirContent::Start {StartDir HiddenDir HiddenFile FileType} \
{
  variable SearchList
 
  set SearchList ""
 
  ::FR_reverseDirContent::DirContent $StartDir $HiddenDir $HiddenFile $FileType
 
  return $SearchList
}


#---we find all subdirectories and give back the wished content
proc ::FR_reverseDirContent::DirContent {StartDir HiddenDir HiddenFile FileType} \
{
  variable SearchList
 
  # we are looking for (sub)directories
  set DirList [glob -nocomplain -type {d x} -directory $StartDir *]
 
  # we are looking for hidden (sub)directories
  if {$HiddenDir} \
  {
    set HiddenDirsList [glob -nocomplain -type {d hidden} -directory $StartDir *]
    set HiddenDirsList [lrange $HiddenDirsList 2 end]
    eval lappend DirList $HiddenDirsList
  }
 
  # we start for each subdirectory a new search 
  if {[llength $DirList] > 0} \
  {
    foreach Arg $DirList \
    {
      ::FR_reverseDirContent::DirContent $Arg $HiddenDir $HiddenFile $FileType
    }
  }
 
  # we find all wished files and join they with its directories
  set FileList [glob -nocomplain -type {f} -directory $StartDir $FileType]
 
  eval lappend SearchList $FileList
 
  # we find all hidden files and append they to the search result
  if {$HiddenFile} \
  {
    set FileList [glob -nocomplain -type {f hidden} -directory $StartDir $FileType]
  
    eval lappend SearchList $FileList
  } 
}


#puts [::FR_reverseDirContent::Start /home/falk/myprograms 1 1 [list *.tcl]]

